opal/util/convert.h File Reference.TH "opal/util/convert.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/util/convert.h \- This file will hopefully not last long in the tree, but it's unfortunately necessary for now. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br

.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBopal_size2int\fP (size_t in, int *out, bool want_check)"
.br
.RI "\fIConvert a size_t to an int. \fP"
.in -1c
.SH "Detailed Description"
.PP 
This file will hopefully not last long in the tree, but it's unfortunately necessary for now. 

There are multiple places in the code base where we need to safely convert from a size_t to an int. However, on some platforms, sizeof(size_t) is larger than sizeof(int), so casting from size_t -> int will result in a compiler warning and potentially data truncation.
.PP
But, unfortunately, we still need to do it. But we definitely do not want compiler warnings. So when sizeof(size_t)>sizeof(int), the solution is the treat the size_t value like an array and dereference the appropriate nibble and cast that to an int (which accounts for both big and little endian machines).
.PP
Most places in the code where this casting must occur are because collision of APIs (e.g., one API requires a size_t and another API requires an int. And in most places, we're not going to overflow the int when casting down into it (e.g., it's the result of a strlen, or the length of the buffer in an ompi_buffer_t -- if that buffer is larger than MAX_INT, we've got other problems!).
.PP
BUT -- the whole premise of casting down to an int is dangerous. So we provide extra protection here to detect overflow situations and print out appropriate warnings. So if this situation ever occurs, we'll still overflow, but we'll have a good indication that it's happening, and where.
.SH "Function Documentation"
.PP 
.SS "int opal_size2int (size_t in, int * out, bool want_check)"
.PP
Convert a size_t to an int. 
.PP
\fBParameters:\fP
.RS 4
\fIin\fP The size_t value to be converted 
.br
\fIout\fP The output int value. 
.br
\fIwant_check\fP Whether to check for truncation or not
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCESS If all went well 
.PP
OMPI_NOT_SUPPORTED if the size_t value was truncated
.RE
.PP
The conversion will always occur. However, if the size_t value was truncated (i.e., sizeof(size_t) > sizeof(int), and the cast down to the int actually changed the value), OMPI_NOT_SUPPORTED will be returned.
.PP
On platforms where sizeof(size_t) <= sizeof(int), this function will aways return OMPI_SUCCESS. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
